/*
 *  swimacumtsbasic.h
 *  swimac
 *
 *  Created by Jerry Pickering on 9/18/09.
 *  Copyright 2008 Sierra Wireless, Inc. All rights reserved.
 *
 */

#ifndef __SWIMACUMTSBASIC_H__
#define __SWIMACUMTSBASIC_H__

#ifdef __cplusplus
extern "C"	{
#endif

#import "swimacrcodes.h"
#import "swimacdatatypes.h"
#import "swimacstructs.h"
	
	
#define LENGTH_FSN 15	// The length of the FSN string
#define LENGTH_DATE 10	// The length of the FSN string
#define LENGTH_ProductStr				16

typedef char SWI_FSN[LENGTH_FSN];
typedef char SWI_BUILD_DATE[LENGTH_DATE];
typedef char SWI_FW_BOOT_VER[15];
typedef char SWI_PRISKUID[15];
typedef char SWI_PRI_VER[15];
typedef struct
{
	UInt16	majorVersion;
	UInt16	minorVersion;
	UInt16	subMinorVersion;
	UInt16	subOEMVersion;
	UInt32	SKUID;
} SWI_TYPE_UMTS_PRI_INFO;
	
typedef struct
{
	UInt16	ModemType;
	UInt32	TechSupport;
	UInt8	Unused[16];
	UInt8	LengthProductStr;					
	UInt8	ProductStr[LENGTH_ProductStr-1];
	
}SWI_TYPE_UMTS_MODEM_TYPE_INFO;
	
//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiGetFSN - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
SWI_RCODE SwiUMTSGetFSN(SWI_U8 *pFSN, SWI_U32 fsnBufferSize, SWI_U32 timeout);

//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiUMTSGetPRIVersion - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
SWI_RCODE SwiUMTSGetPRIInfo( SWI_TYPE_UMTS_PRI_INFO *pBuffer, SWI_U32 timeout );
//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiUMTSGetPRIVersion - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
SWI_RCODE SwiUMTSGetPRIVersion(SWI_U16 *majorVer, SWI_U16 *minorVer,  SWI_U32 timeout );

//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiGetPRISKUID - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
SWI_RCODE SwiUMTSGetPRISKUID(SWI_U32 *priskuid, SWI_U32 timeout );
	
	//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiGetFirmwareVersionBuildDate - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
//SWI_RCODE SwiGetFirmwareVersionBuildDate(SWI_U8 *pFWBuild,SWI_U32 fwBufferSize, SWI_U32 timeout );
SWI_RCODE SwiUMTSGetFirmwareVersionBuildDate(SWI_U8 *pBuffer,SWI_U32 bufferSize, SWI_U32 timeout );
	
//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiFirmwareBootVersion - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
//SWI_RCODE SwiFirmwareBootVersion( SWI_U32 timeout );
SWI_RCODE SwiUMTSFirmwareBootVersion( SWI_U8 *pBuffer,SWI_U32 bufferSize,SWI_U32 timeout );

//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiUMTSGetFirmwareVersion - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
//SWI_RCODE SwiUMTSGetFirmwareVersion( SWI_U32 timeout );
SWI_RCODE SwiUMTSGetFirmwareVersion(SWI_U8 *pBuffer,SWI_U32 bufferSize, SWI_U32 timeout );


//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiUMTSGetFirmwareVersion - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
//SWI_RCODE SwiUMTSGetFirmwareVersion( SWI_U32 timeout );
SWI_RCODE SwiUMTSGetHardwareVersion(SWI_U16 *pVersion, SWI_U32 timeout );
		
	
//////////////////////////////////////////////////////////////////////////////////
//
// Name:        SwiGetModemType - 
//
// Purpose:     This function will be used to 
//				
//
// Parameters:  timeout[IN]             Function timeout in milliseconds
//
// Return:      See SwiRcodes.h
//
// Notes:		
//	
//
//////////////////////////////////////////////////////////////////////////////////
SWI_RCODE SwiUMTSGetModemType(SWI_TYPE_UMTS_MODEM_TYPE_INFO *pBuffer, SWI_U32 timeout );


//**********************************************************************************
//	SwiGetIOTAData
//		This call returns all the IOTA data in one structure
//		the primary use is to check all the "GET" calls for
//		IOTA
//**********************************************************************************
typedef struct allUMTSData
{
	SWI_RCODE	_ret[1];
	bool		_iotaDisabled;
} allUMTSData;

SWI_RCODE SwiGetUMTSData(allUMTSData *data);

#ifdef __cplusplus
}
#endif

#endif // __SWIMACIOTA_H__
